Package org.kapott.hbci.GV

## Class GVTAN2Step

- java.lang.Object
- - org.kapott.hbci.GV.HBCIJobImpl
  - - org.kapott.hbci.GV.GVTAN2Step

All Implemented Interfaces:
  `HBCIJob`

    public class GVTAN2Step
    extends HBCIJobImpl

Author:
  stefan.palme

### Field Summary

### Fields inherited from class org.kapott.hbci.GV.HBCIJobImpl

`jobResult`

### Constructor Summary

Constructors
`GVTAN2Step​(HBCIHandler handler)` ct.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`protected void` `extractResults​(HBCIMsgStatus msgstatus, java.lang.String header, int idx)`
`static java.lang.String` `getLowlevelName()`
`boolean` `haveTan()` Liefert true, wenn fuer den Auftrag ein HKTAN erzeugt wurde.
`HBCIJobImpl` `redo()` Liefert den ggf erneut auszufuehrenden Job.
`protected void` `saveReturnValues​(HBCIMsgStatus status, int sref)`
`void` `setParam​(java.lang.String paramName, java.lang.String value)` Setzen eines Job-Parameters.
`void` `setProcess​(KnownTANProcess p)` Speichert den Prozess-Schritt des HKTAN.
`void` `setStep2​(GVTAN2Step step2)` Speichert die Referenz auf das zweite HKTAN im ersten HKTAN.
`void` `setTask​(HBCIJobImpl task)` Speichert eine Referenz auf den eigentlichen Geschaeftsvorfall.

### Methods inherited from class org.kapott.hbci.GV.HBCIJobImpl

`acceptsParam, addConstraint, addConstraint, addSignaturePassport, addToQueue, addToQueue, applyOffset, canNationalAcc, checkAccountCRC, createJobSegment, createJobSegment, fillJobResult, getChallengeParam, getExternalId, getHBCICode, getJobName, getJobParameterNames, getJobRestrictions, getJobResult, getJobResultNames, getLowlevelParam, getLowlevelParams, getMainPassport, getMaxNumberPerMsg, getMinSigs, getName, getOrderAccount, getParentHandler, getSecurityClass, getSegVersion, getSignaturePassports, redoAllowed, setExternalId, setIdx, setLowlevelParam, setParam, setParam, setParam, setParam, setParam, setParam, setParam, setParam, setSegVersion, skip, skipped, tanApplied, twoDigitValueInList, verifyConstraints`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### GVTAN2Step

    public GVTAN2Step​(HBCIHandler handler)

ct.

Parameters:
  `handler` -

### Method Detail

#### getLowlevelName

    public static java.lang.String getLowlevelName()

#### setProcess

    public void setProcess​(KnownTANProcess p)

Speichert den Prozess-Schritt des HKTAN.

Parameters:
  `p` - der Prozess-Schritt.

#### setParam

    public void setParam​(java.lang.String paramName,
                         java.lang.String value)

Description copied from class: `HBCIJobImpl`

Setzen eines Job-Parameters. Für alle Highlevel-Jobs ist in der Package-Beschreibung zum Package `org.kapott.hbci.GV` eine Auflistung aller Jobs und deren Parameter zu finden. Für alle Lowlevel-Jobs kann eine Liste aller Parameter entweder mit dem Tool `ShowLowlevelGVs` oder zur Laufzeit durch Aufruf der Methode `HBCIHandler.getLowlevelJobParameterNames(String)` ermittelt werden.

Bei Verwendung dieser oder einer der anderen `setParam()`-Methoden werden zusätzlich einige der Job-Restriktionen (siehe `HBCIJobImpl.getJobRestrictions()`) analysiert. Beim Verletzen einer der überprüften Einschränkungen wird eine Exception mit einer entsprechenden Meldung erzeugt. Diese Überprüfung findet allerdings nur bei Highlevel-Jobs statt.

Specified by:
  `setParam` in interface `HBCIJob`
Overrides:
  `setParam` in class `HBCIJobImpl`
Parameters:
  `paramName` - der Name des zu setzenden Parameters.
  `value` - Wert, auf den der Parameter gesetzt werden soll
See Also:
  `HBCIJobImpl.setParam(java.lang.String, java.lang.String)`

#### setStep2

    public void setStep2​(GVTAN2Step step2)

Speichert die Referenz auf das zweite HKTAN im ersten HKTAN. Wird fuer Prozess-Variante 2 benoetigt.

Parameters:
  `step2` - die Referenz auf den ersten HKTAN.

#### setTask

    public void setTask​(HBCIJobImpl task)

Speichert eine Referenz auf den eigentlichen Geschaeftsvorfall.

Parameters:
  `task` -

#### saveReturnValues

    protected void saveReturnValues​(HBCIMsgStatus status,
                                    int sref)

Overrides:
  `saveReturnValues` in class `HBCIJobImpl`

#### redo

    public HBCIJobImpl redo()

Description copied from class: `HBCIJobImpl`
Liefert den ggf erneut auszufuehrenden Job. Die Default-Implementierung liefert "this", wenn die Bank ein 3040 zurueckgemeldet hat. Das kann aber auch ein anderer sein, als "this". Naemlich bei HKTAN in Prozess-Variante #2. Dort liefert es stattdessen den eigentlichen GV.

Overrides:
  `redo` in class `HBCIJobImpl`
Returns:
  den ggf erneut auszufuehrenden Job.
See Also:
  `HBCIJobImpl.redo()`

#### haveTan

    public boolean haveTan()

Description copied from class: `HBCIJobImpl`
Liefert true, wenn fuer den Auftrag ein HKTAN erzeugt wurde.

Overrides:
  `haveTan` in class `HBCIJobImpl`
Returns:
  true, wenn fuer den Auftrag ein HKTAN erzeugt wurde.
See Also:
  `HBCIJobImpl.haveTan()`

#### extractResults

    protected void extractResults​(HBCIMsgStatus msgstatus,
                                  java.lang.String header,
                                  int idx)

Overrides:
  `extractResults` in class `HBCIJobImpl`
See Also:
  `HBCIJobImpl.extractResults(org.kapott.hbci.status.HBCIMsgStatus, java.lang.String, int)`